/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.homePage.modular.hmcarousel.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.unis.common.enums.CommonSortOrderEnum;
import com.unis.common.exception.CommonException;
import com.unis.common.page.CommonPageRequest;
import com.unis.homePage.modular.hmcarousel.entity.BizHmCarousel;
import com.unis.homePage.modular.hmcarousel.mapper.BizHmCarouselMapper;
import com.unis.homePage.modular.hmcarousel.param.BizHmCarouselAddParam;
import com.unis.homePage.modular.hmcarousel.param.BizHmCarouselEditParam;
import com.unis.homePage.modular.hmcarousel.param.BizHmCarouselIdParam;
import com.unis.homePage.modular.hmcarousel.param.BizHmCarouselPageParam;
import com.unis.homePage.modular.hmcarousel.service.BizHmCarouselService;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 首页管理-头条轮播管理表Service接口实现类
 *
 * @author shine
 * @date  2024/05/20 19:25
 **/
@Service
public class BizHmCarouselServiceImpl extends ServiceImpl<BizHmCarouselMapper, BizHmCarousel> implements BizHmCarouselService {

    @Resource
    private BizHmCarouselMapper bizHmCarouselMapper;

    @Override
    public Page<BizHmCarousel> page(BizHmCarouselPageParam bizHmCarouselPageParam) {
        QueryWrapper<BizHmCarousel> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isNotEmpty(bizHmCarouselPageParam.getHeadlineTitle())) {
            queryWrapper.lambda().like(BizHmCarousel::getHeadlineTitle, bizHmCarouselPageParam.getHeadlineTitle());
        }
        if(ObjectUtil.isNotEmpty(bizHmCarouselPageParam.getStatus())) {
            queryWrapper.lambda().eq(BizHmCarousel::getStatus, bizHmCarouselPageParam.getStatus());
        }
        if(ObjectUtil.isAllNotEmpty(bizHmCarouselPageParam.getSortField(), bizHmCarouselPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(bizHmCarouselPageParam.getSortOrder());
            queryWrapper.orderBy(true, bizHmCarouselPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(bizHmCarouselPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByDesc(BizHmCarousel::getPublishTime);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(BizHmCarouselAddParam bizHmCarouselAddParam) {
        BizHmCarousel bizHmCarousel = BeanUtil.toBean(bizHmCarouselAddParam, BizHmCarousel.class);
        this.save(bizHmCarousel);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(BizHmCarouselEditParam bizHmCarouselEditParam) {
        BizHmCarousel bizHmCarousel = this.queryEntity(bizHmCarouselEditParam.getId());
        BeanUtil.copyProperties(bizHmCarouselEditParam, bizHmCarousel);
        this.updateById(bizHmCarousel);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<BizHmCarouselIdParam> bizHmCarouselIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(bizHmCarouselIdParamList, BizHmCarouselIdParam::getId));
    }

    @Override
    public BizHmCarousel detail(BizHmCarouselIdParam bizHmCarouselIdParam) {
        return this.queryEntity(bizHmCarouselIdParam.getId());
    }

    @Override
    public BizHmCarousel queryEntity(String id) {
        BizHmCarousel bizHmCarousel = this.getById(id);
        if(ObjectUtil.isEmpty(bizHmCarousel)) {
            throw new CommonException("首页管理-头条轮播管理表不存在，id值为：{}", id);
        }
        return bizHmCarousel;
    }

    @Override
    public void batchUpdateStatus(List<BizHmCarousel> list) {

        for(BizHmCarousel bizHmCarousel:list){
            this.updateById(bizHmCarousel);
        }
    }

}
